<?php

namespace NL\NlMenubuilder\ViewHelpers\Menu;

use NL\NlMenubuilder\ViewHelpers\Menu\Controller\RenderController;
use TYPO3\CMS\Fluid\Core\Widget\AbstractWidgetViewHelper;

class RenderViewHelper extends AbstractWidgetViewHelper
{
    /**
     * @var RenderController
     */
    protected $controller;

    /**
     * Inject controller
     *
     * @param RenderController $controller
     */
    public function injectController(RenderController $controller): void
    {
        $this->controller = $controller;
    }

    /**
     * Initialize arguments
     *
     * @return void
     */
    public function initializeArguments(): void
    {
        $this->registerArgument('uid', 'int', 'UID of the menu', true);
        $this->registerArgument('disableSecurityCheck', 'bool', 'Disable security check', false, false);
    }

    /**
     * @return \TYPO3\CMS\Extbase\Mvc\ResponseInterface
     */
    public function render(): \TYPO3\CMS\Extbase\Mvc\ResponseInterface
    {
        return $this->initiateSubRequest();
    }
}
